%IDC_Add          = 101
%IDC_Dialogs      = 102
%IDC_Controls     = 103
%IDC_Run          = 104
%IDC_Textbox      = 105
%IDC_Label        = 201
%IDC_Text         = 220
%IDC_Styles       = 230
%IDC_ExStyles     = 250
%IDC_Modal        = 261
%IDC_Modeless     = 262
%IDC_Status       = 270
%IDC_MenuItem     = 301
%IDC_AddDn        = 302
%IDC_AddUp        = 303
%IDC_MenuList     = 304
%IDC_Left         = 305
%IDC_Right        = 306
%IDC_Divider      = 307
%IDC_AccelKey     = 308
%IDC_DelItem      = 309
%IDC_EdtItem      = 310
%IDC_Finish       = 311
%IDC_Dummy        = 400
%IDM_Open         = 901
%IDM_Save         = 902
%IDM_SaveAs       = 903
%IDM_PBEdit       = 904
%IDM_Exit         = 905
%IDM_EdtDlg       = 911
%IDM_DelDlg       = 912
%IDM_EdtCtl       = 913
%IDM_DelCtl       = 914
%IDM_Restart      = 915
%IDM_ViewSrc      = 921
%IDM_ViewInc      = 922

TYPE dialogInfo
   numCtrls      AS BYTE  'number of controls
   dlgNew        AS BYTE  'number of stmts for DIALOG NEW (incl continuations)
   menuStmts     AS BYTE  'number of statements in menubar
   statusStmts   AS BYTE  'number of statements in statusbar
END TYPE

TYPE controlInfo
   dlgNo         AS BYTE  'dialog that the control is anchored to
   ctrlAdd       AS BYTE  'number of stmts for CONTROL ADD (incl continuations)
   ntype         AS BYTE  'type of control (Buttons,...)
END TYPE
 
GLOBAL hDlg AS LONG 
GLOBAL hMenu AS LONG
GLOBAL hStatus AS LONG
GLOBAL hAddStatus AS LONG
GLOBAL hAddMenu AS LONG
GLOBAL hFileMenu AS LONG
GLOBAL hEditMenu AS LONG
GLOBAL hViewMenu AS LONG
GLOBAL gOldEditProc AS LONG
GLOBAL fileChanged AS LONG
GLOBAL origDir AS STRING
GLOBAL thisFile AS STRING
GLOBAL PBEditor AS STRING
GLOBAL numDialogs AS LONG
GLOBAL numStyles AS LONG
GLOBAL numExStyles AS LONG
GLOBAL numSrcStmts AS LONG
GLOBAL numIncStmts AS LONG
GLOBAL numControls AS LONG
GLOBAL nCtrlType AS LONG
GLOBAL dialogNo AS LONG
GLOBAL controlNo AS LONG
GLOBAL editMode AS LONG
GLOBAL viewMode AS LONG
GLOBAL savPosn AS LONG
GLOBAL ctlName AS STRING
GLOBAL dlgName AS STRING
GLOBAL source() AS STRING
GLOBAL include() AS STRING 
GLOBAL dlgInfo() AS dialogInfo
GLOBAL ctrlNames() AS STRING
GLOBAL ctrlInfo() AS controlInfo
GLOBAL controlTypes() AS STRING
GLOBAL numTypeCtrls() AS LONG
GLOBAL styles() AS STRING
GLOBAL exStyles() AS STRING
GLOBAL editData() AS STRING

DECLARE SUB addMenubar()
DECLARE SUB addStatusbar()
DECLARE SUB setStatus(LONG, STRING)
DECLARE SUB listStmts(OPT BYVAL LONG)
DECLARE SUB insSrcLines(LONG, LONG)
DECLARE SUB delSrcLines(LONG, LONG)
DECLARE SUB insIncLines(LONG, LONG)
DECLARE SUB delIncLines(LONG, LONG)
DECLARE SUB addMsgHandler(STRING)
DECLARE SUB addIncludeStmt(STRING)
DECLARE SUB redefineIncConstants()
DECLARE SUB replaceToken(STRING, STRING)
DECLARE SUB insertControlData()
DECLARE SUB addDDTstmt(LONG, STRING, STRING, STRING)
DECLARE SUB initControlsCombobox()
DECLARE SUB restart()
DECLARE SUB build()
DECLARE SUB readTheFile()
DECLARE SUB saveTheFile()
DECLARE SUB initSource()
DECLARE SUB add_Dialog()
DECLARE SUB add_Control()
DECLARE SUB add_Statusbar()
DECLARE SUB add_Menubar()
DECLARE SUB del_Menubar()
DECLARE SUB del_Statusbar()                 
DECLARE FUNCTION browseForFile() AS STRING
DECLARE FUNCTION fileHasChanged() AS LONG
DECLARE FUNCTION getStyle(LONG) AS STRING
DECLARE FUNCTION getExStyle(LONG) AS STRING
DECLARE FUNCTION getDlgStmt(LONG, OPT BYVAL LONG, BYVAL STRING) AS LONG
DECLARE FUNCTION EditSubClass(BYVAL LONG, BYVAL LONG, BYVAL LONG, BYVAL LONG) AS LONG
DECLARE CALLBACK FUNCTION dlgProc()
DECLARE CALLBACK FUNCTION add_DialogProc()
DECLARE CALLBACK FUNCTION add_ControlProc()
DECLARE CALLBACK FUNCTION add_StatusbarProc()
DECLARE CALLBACK FUNCTION add_MenubarProc()

'---------------------------------------------------------------------------------------
'Program notes
'---------------------------------------------------------------------------------------
'  source()        holds source statements
'  include()       holds include statements 
'  dlgInfo()       dialog info structure: [menuStmts, statusStmts]
'  ctrlInfo()      controlInfo structure: [dlgNo, nStyle, nType] 
'  ctrlNames()     control names (default names such as Button1)
'  controlTypes()  type of controls available (Button, Label, Textbox, listbox, ...)
'  numTypeCtrls()  number of controls for each of the control types
                  
'  nCtrlType       control type index for controls()
'  dialogNo        dialog number from dialog combobox
'  controlNo       control number from control combobox
                  
'  dlgName         dialog name (Dialog1)
'  dlgHandle       handle for dialog (hDialog1)
'  ctlName         control name (Button1, Label1, Textbox1, Listbox1, ...) 
'  parent          parent of control (Dialog1)
'  parentHandle    handle of parent (hDialog1)

'  numDialogs      number of dialogs defined
'  numStyles       number of styles available for dialogs or particular controls
'  numSrcStmts     number of source statements defined in source()
'  numIncStmts     number of include statements defined in include()
'  numControls     number of ctrlNames() and ctrlInfo() 

'  origDir         directory holding "DDT Jumpstart.exe"
'  thisFile        source file holding source()
'  PBEditor        path of PowerBasic editor (c:\pbwin80\bin\pbedit.exe)

'  nStyle          bit definition to specify styles
'  itemData        dialog combobox: dialog styles
'  itemData        control combobox: controlNo index into ctrlNames() and ctrlInfo() 

'  limits          99 controls per dialog
'  IDC constants   100 * dialogNo + n  (n = 1 to 99)
'                  e.g. %IDC_Button409 = 409 ...for 9th control on 4th dialog

'---------------------------------------------------------------------------------------
'Open BAS file
'---------------------------------------------------------------------------------------
' - read source file
' - read include file
' - scan for SUBs and FUNCTIONs that have a DIALOG NEW statement
'   and for each of these add the dialog name to the dialogs combobox and all of the
'   contained controls found from the CONTROL ADD statement to the controls combobox
'